hdu 1518 square

来源:互联网 发布:java中如何处理高并发 编辑:程序博客网 时间:2024/05/29 03:58

Square

Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 11794 Accepted Submission(s): 3784


Problem Description
Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square?

Input
The first line of input contains N, the number of test cases. Each test case begins with an integer 4 <= M <= 20, the number of sticks. M integers follow; each gives the length of a stick - an integer between 1 and 10,000.

Output
For each case, output a line containing "yes" if is is possible to form a square; otherwise output "no".

Sample Input
34 1 1 1 15 10 20 30 40 508 1 7 2 6 4 4 3 5

Sample Output
yesnoyes


题目的意思简单。。拼成正方形。

思路:dfs,注意两个地方防超时,注释在代码里了


<span style="font-size:18px;">#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>using namespace std;int a[50],flag,len,M,N,vis[50],cnt,sum;void dfs(int sum,int pos,int cnt){    int i;    if(sum==len)    {        cnt++;        if(cnt==3){flag++;printf("yes\n");return;}//还有这里,只要能做到拼成三条边,剩下的肯定就可以拼成第四条边了        else dfs(0,0,cnt);        return;    }    else for(i=pos;i<M;i++)//这里如果不用pos,直接从0开始的话会TE,因为搜重复了==。。看了别人的代码才发现    {        if(flag!=0)break;        if(!vis[i]&&sum+a[i]<=len)        {            vis[i]=1;            dfs(sum+a[i],i,cnt);            vis[i]=0;        }        if(sum+a[i]>len)break;    }}int main(){    int j,sum1;    scanf("%d",&N);    while(N--)    {        sum1=0;        flag=0;        scanf("%d",&M);        for(j=0;j<M;j++)        {            scanf(" %d",&a[j]);            sum1+=a[j];        }        sort(a,a+M);        if(sum1%4!=0){printf("no\n");continue;}        else len=sum1/4;        for(j=0;j<M;j++)        {            if(a[j]>len){printf("no\n");flag++;break;}        }        if(flag!=0)continue;        memset(vis,0,sizeof(vis));        dfs(0,0,0);        if(!flag)printf("no\n");    }    return 0;}</span>
























0 0